<?php
require_once ($oPlugin->cPluginPfad."classes/SpamProtector.class.php");
require_once ($oPlugin->cPluginPfad."classes/SpamStop.class.php");
require_once ($oPlugin->cPluginPfad."classes/HttpBl.class.php");
require_once ($oPlugin->cPluginPfad."classes/class.lfs_spamprotector.helper.php");
$oHelper = new lfsSpamProtectorHelper($oPlugin, $oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_debugmode_active']=='Y'?true:false);

// Http:BL aktiv und Access-Key gesetzt?
if ($oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_projecthoneypot_active'] == 'Y' &&
$oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_projecthoneypot_accesskey'] != "") {
    $h = new Lilfoot\HttpBl($oPlugin, $oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_projecthoneypot_accesskey']);

    if( $oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_projecthoneypot_testmode'] == "Y" ) {
        $ip = $oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_projecthoneypot_testmodus_ip'];
    } else {
        $ip = $_SERVER['REMOTE_ADDR'];
    }

    $r=$h->query($ip);

    if ($r == 2) { //nur bei r=2 handelt es sich um einen potentiellen Angriff

        if (($h->score >= $oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_projecthoneypot_minthreats'])
            && ($h->days <= $oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_projecthoneypot_maxdays'])) {	//prüfe, ob die Parameter erfüllt werden

            if ($oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_debugmode_active'] == 'Y') {
                Jtllog::writeLog($oPlugin->cName . ": Access to page was blocked due to response of http:BL-Project", JTLLOG_LEVEL_DEBUG);
                Jtllog::writeLog($oPlugin->cName . ": Blocked IP is -" . $ip . "-", JTLLOG_LEVEL_DEBUG);
            }

            $oTemplateVars = array();

            $oHTTPBlInsert = new stdClass();
            $oHTTPBlInsert->httpbl_id = NULL;
            $oHTTPBlInsert->ip = $ip;
            $oHTTPBlInsert->date_logged = date("Y-m-d H:i:s");
            $oHTTPBlInsert->last_activity = $h->days;
            $oHTTPBlInsert->threats = $h->score;
            $oHTTPBlInsert->type_txt = $h->type_txt;
            $oHTTPBlInsert->script = $_SERVER['REQUEST_URI'];
            Shop::DB()->insertRow("xplugin_lfs_spamprotector_httpbl_log", $oHTTPBlInsert);

            $oTemplateVars['httpbl_test_flag'] = $oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_projecthoneypot_testmode'];
            $oTemplateVars['httpbl_key'] = $oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_projecthoneypot_accesskey'];
            $oTemplateVars['max_days'] = $oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_projecthoneypot_maxdays'];
            $oTemplateVars['last_activity'] = $h->days;
            $oTemplateVars['min_threads'] = $oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_projecthoneypot_minthreats'];
            $oTemplateVars['threat'] = $h->score;
            $oTemplateVars['typ'] = $h->type_txt;
            $oTemplateVars['ip'] = $ip;
            $oTemplateVars['plugin_spamprotector'] = $oPlugin;

            $template_file = $oPlugin->cFrontendPfad."/template/blocked_by_httpbl_page.tpl";

            if (file_exists($oPlugin->cFrontendPfad."/template/blocked_by_httpbl_page_custom.tpl"))
                $template_file = $oPlugin->cFrontendPfad."/template/blocked_by_httpbl_page_custom.tpl";

            $content = Shop::Smarty()->fetch($template_file, $oTemplateVars);
            header('HTTP/1.0 403 Forbidden');
            echo $content;
            exit();
        }
    }
}

if ($oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_honeypot_input_active'] == 'Y'
    || $oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_honeypot_checkbox_active'] == 'Y')
{
    if (isset($_SESSION['jtl_token'])) {
        $sp = \Lilfoot\SpamProtector::getInstance($oPlugin);
        if ($oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_honeypot_input_active'] == 'Y')
            $sp->addTrap(new \Lilfoot\HoneyPotTextInputTrap($oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_honeypot_input_name'], $oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_honeypot_input_label'], $oPlugin));

        if ($oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_honeypot_checkbox_active'] == 'Y')
            $sp->addTrap(new \Lilfoot\HoneyPotCheckboxTrap($oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_honeypot_checkbox_name'], $oPlugin->oPluginEinstellungAssoc_arr['lfs_spamprotector_honeypot_checkbox_label'], $oPlugin));

        $formToken = SHOP::Smarty()->getTemplateVars('jtl_token');
        SHOP::Smarty()->assign('jtl_token', $formToken . $sp->getInputHTML());
    }
}
